<script lang="ts">
import Vue, { PropType } from 'vue';
import {
  CtfEntry,
  CtfTheSourceArticlePage,
  CtfTheSourceAuthor,
} from '~/models';
import { IsMobileMixin } from '~/mixins';
import { getUrlFromContentfulImage } from '~/common/util';
import Breadcrumb from '~/components/common/breadcrumb.vue';
import { THE_SOURCE_TYPES } from '~/common/constants';

export default Vue.extend({
  name: 'TheSourceHero',
  components: { Breadcrumb },
  mixins: [IsMobileMixin],
  props: {
    article: {
      type: Object as PropType<CtfTheSourceArticlePage>,
      required: true,
    },
  },
  data() {
    return {
      types: THE_SOURCE_TYPES,
      crumbs: [
        {
          title: this.$i18n.t('articles.theSource'),
          href: '/the-source/',
        },
        {
          title: this.article.category.fields.title,
          href: `/${this.article.category.fields.slug}/`,
        },
        { title: this.article.headline, hidden: true },
      ],
    };
  },
  computed: {
    formattedDate() {
      if (!this.article.date) {
        return;
      }

      const date = new Date(this.article.date);
      const month = date.toLocaleString('en-US', { month: 'long' });
      // getUTCDate is precise to the minute vs getDate
      const day = date.getUTCDate();
      const year = date.getFullYear();

      return `${month} ${day}, ${year}`;
    },
    heroImage() {
      return {
        src: getUrlFromContentfulImage(this.article.heroImage, 1460, 760),
        alt: this.article.heroImage?.fields?.file?.title,
      };
    },
    webinarDate() {
      const date = new Date(this.article.date);
      const options = { hour: 'numeric', minute: '2-digit', hour12: true };

      const ptTime = `${date.toLocaleString('en-US', { ...options, timeZone: 'America/Los_Angeles' })} PT`;
      const utcTime = `${date.toLocaleString('en-US', { ...options, timeZone: 'UTC' })} UTC`;

      return `${ptTime} / ${utcTime}`;
    },
    showDate() {
      if (this.article.type === THE_SOURCE_TYPES.GUIDE) return false;

      if (this.article.type === THE_SOURCE_TYPES.WEBINAR) {
        const currentDate = new Date();
        const articleDate = new Date(this.article.date);

        return articleDate > currentDate;
      }

      return true;
    },
    watchWebinar() {
      return !this.showDate && this.article.gatedAsset?.fields.gatedAssetLink;
    },
  },
  methods: {
    authorHeadshot(author: CtfEntry<CtfTheSourceAuthor>) {
      return {
        src: getUrlFromContentfulImage(author?.fields?.headshot, 160, 160),
        alt: author?.fields?.name || 'Author Headshot',
      };
    },
  },
});
</script>

<template>
  <section class="article-hero">
    <SlpContainer>
      <Breadcrumb class="article-hero__breadcrumb" :crumbs="crumbs" />
      <div class="slp-flex">
        <SlpIcon
          v-if="article.type !== types.REGULAR"
          name="lock"
          variant="product"
          class="slp-mr-4"
        />
        <SlpTypography tag="h5" variant="all-caps">{{
          $t(`articles.${article.type?.toLowerCase() || 'article'}`)
        }}</SlpTypography>
      </div>
      <SlpRow>
        <SlpColumn class="article-hero__content" :cols="8" size="lg">
          <SlpTypography variant="heading2-bold" tag="h1" class="slp-mb-16">
            {{ article.headline }}
          </SlpTypography>
          <SlpTypography
            v-if="article.description"
            tag="p"
            variant="body1"
            class="slp-mb-16"
            >{{ article.description }}</SlpTypography
          >
          <div v-if="showDate" class="slp-mb-16">
            <template v-if="formattedDate">
              <SlpTypography variant="body3" tag="span">{{
                formattedDate
              }}</SlpTypography>
              <span
                v-if="article.timeToRead || webinarDate"
                class="separator"
              />
            </template>
            <SlpTypography variant="body3" tag="span">{{
              article.type === types.WEBINAR ? webinarDate : article.timeToRead
            }}</SlpTypography>
          </div>
          <SlpButton
            v-show="article.type === types.WEBINAR && showDate"
            variant="primary"
            href="#form"
            class="slp-mb-24"
          >
            {{ $t(`articles.register`) }}
            <SlpIcon
              class="slp-ml-8"
              name="arrow-down"
              variant="product"
              size="sm"
            />
          </SlpButton>
          <SlpButton
            v-show="article.type === types.WEBINAR && watchWebinar"
            variant="primary"
            href="#form"
            class="slp-mb-24"
          >
            {{ $t(`articles.watch`) }}
            <SlpIcon
              class="slp-ml-8"
              name="arrow-down"
              variant="product"
              size="sm"
            />
          </SlpButton>
          <div v-if="heroImage" class="article-hero__image">
            <img v-bind="heroImage" />
          </div>
        </SlpColumn>
        <!-- AUTHOR & SPEAKERS START -->
        <SlpColumn :cols="4" size="lg">
          <template v-if="article.author && article.type === types.REGULAR">
            <div class="article-hero__author">
              <img v-bind="authorHeadshot(article.author)" />
              <div class="slp-flex slp-flex-column">
                <SlpButton
                  :href="`/${article.author.fields.slug}/`"
                  variant="tertiary"
                >
                  <SlpTypography tag="span" variant="body3-bold">{{
                    article.author.fields.name
                  }}</SlpTypography>
                </SlpButton>
                <SlpTypography variant="body3" tag="span">{{
                  article.author.fields.role
                }}</SlpTypography>
              </div>
            </div>
          </template>
          <template v-if="article.speakers && article.type === types.WEBINAR">
            <div class="article-hero__speakers">
              <SlpTypography
                tag="h5"
                variant="all-caps"
                class="slp-px-lg-32 slp-pb-md-16"
                >{{ $t(`articles.speakers`) }}</SlpTypography
              >
              <div
                v-for="speaker in article.speakers"
                :key="speaker.sys.id"
                class="article-hero__author"
              >
                <img v-bind="authorHeadshot(speaker)" />
                <div class="slp-flex slp-flex-column">
                  <SlpButton
                    :href="`/${speaker.fields.slug}/`"
                    variant="tertiary"
                  >
                    <SlpTypography tag="span" variant="body3-bold"
                      >{{ speaker.fields.name }}
                    </SlpTypography>
                  </SlpButton>
                  <SlpTypography variant="body3" tag="span"
                    >{{ speaker.fields.role }}
                  </SlpTypography>
                </div>
              </div>
            </div>
          </template>
        </SlpColumn>
        <!-- AUTHOR & SPEAKERS END -->
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
$hero-spacing: 200px;

.separator {
  border-left: 1px solid $color-surface-400;
  height: 12px;
  margin: 0 $spacing-8;
}

.article-hero {
  position: relative;
  background-color: $color-surface-100;

  @media (width > $breakpoint-lg) {
    margin-bottom: $hero-spacing;
  }

  .slp-container {
    padding-top: $spacing-32;
    padding-bottom: $spacing-32;
  }

  &__breadcrumb {
    padding-bottom: $spacing-24;

    &:deep {
      .slp-text-body3 {
        font-weight: $font-weight-bold !important;
      }

      .mobile-chevron {
        display: none;
      }

      .hide-in-mobile {
        display: flex;
      }

      .breadcrumb__crumb {
        color: $color-primary-200 !important;

        &:hover {
          color: $color-text-link-100 !important;
          text-decoration-color: $color-text-link-100 !important;
        }
      }
    }
  }

  &__image {
    position: relative;
    z-index: 2;

    @media (width > $breakpoint-lg) {
      margin-bottom: -$hero-spacing;
    }

    & img {
      width: 100%;
      max-height: 800px;
      border-radius: 8px;
    }
  }

  &__speakers {
    margin-top: $spacing-16;

    @media (width > $breakpoint-lg) {
      margin-top: -$spacing-16;
    }
  }

  &__author {
    display: flex;
    align-items: center;
    margin: $spacing-16 0;

    @media (width >= $breakpoint-lg) {
      padding: 0 $spacing-32;
    }

    .slp-btn {
      text-align: start;
      padding: $spacing-4 0;

      &:hover {
        color: $color-text-link-100;
        text-decoration-color: $color-text-link-100;
      }
    }

    img {
      margin-right: $spacing-8;
      width: 80px;
      height: 80px;
      border-radius: 80px;
    }
  }
}
</style>
